function openWindow(strURL) {
	window.open(strURL, "Help", "left=" + (screen.width - 550) + ", top=0, menubar=no, resizable=no scrollbars=yes, height=400, width=525");
}

function autoComplete(objField, objSelect, strProperty, bForceMatch) {
	var i             = "";
	var bFound        = "";
	var strCursorKeys = "";
	var objTextRange1 = "";
	var strOldValue   = "";
	var strNewValue   = "";
	var objTextRange2 = "";

	bFound = false;

	for (i = 0; i < objSelect.options.length; i++) {
		if (objSelect.options[i][strProperty].toUpperCase().indexOf(objField.value.toUpperCase()) == 0) {
			bFound = true;

			break;
		}
	}

	if (bFound) {
		objSelect.selectedIndex = i;
	}
	else {
		objSelect.selectedIndex = -1;
	}

	if (objField.createTextRange) {
		if (bForceMatch && !bFound) {
			objField.value = objField.value.substring(0, objField.value.length - 1);

			return;
		}

		strCursorKeys = "8;46;37;38;39;40;33;34;35;36;45;";

		if (strCursorKeys.indexOf(event.keyCode + ";") == -1) {
			objTextRange1 = objField.createTextRange();
			strOldValue   = objTextRange1.text;
			strNewValue   = bFound ? objSelect.options[i][strProperty] : strOldValue;

			if (strNewValue != objField.value) {
				objField.value = strNewValue;

				objTextRange2 = objField.createTextRange();

				objTextRange2.moveStart('character', strOldValue.length);

				objTextRange2.select();
			}
		}
	}
}

function moveSelectedItems(objSource, objDestination) {
	var i                    = "";
	var strSourceArray       = new Array();
	var strDestinationArray  = new Array();
	var strLookupArray       = new Array();
	var intSourceLength      = "";
	var intDestinationLength = "";
	var objErase             = new Option();

	for (i = 0; i < objDestination.options.length; i++) {
		strLookupArray[objDestination.options[i].text] = objDestination.options[i].value;

		strDestinationArray[i] = objDestination.options[i].text;
	}

	intSourceLength      = 0;
	intDestinationLength = strDestinationArray.length;

	for(i = 0; i < objSource.options.length; i++) {
		strLookupArray[objSource.options[i].text] = objSource.options[i].value;

		if (objSource.options[i].selected && objSource.options[i].value != "") {
			strDestinationArray[intDestinationLength] = objSource.options[i].text;

			intDestinationLength++;
		}
		else {
			strSourceArray[intSourceLength] = objSource.options[i].text;

			intSourceLength++;
		}
	}

	strSourceArray.sort();
	strDestinationArray.sort();

	objSource.length      = 0;
	objDestination.length = 0;

	for(i = 0; i < strSourceArray.length; i++) {
		var objErase = new Option();

		objErase.value = strLookupArray[strSourceArray[i]];
		objErase.text  = strSourceArray[i];
		objSource[i]   = objErase;
	}

	for(i = 0; i < strDestinationArray.length; i++) {
		var objErase = new Option();

		objErase.value    = strLookupArray[strDestinationArray[i]];
		objErase.text     = strDestinationArray[i];
		objDestination[i] = objErase;
	}
}

function checkInput1() {
	if (document.AddUser.Username.value == "") {
		alert("You must enter a Username.");

		return false;
	}
	else if (document.AddUser.Username.value.indexOf("\\") == -1) {
		alert("The Username must be in the form of Domain\\Username.");

		return false;
	}
	else {
		if (badCharacters(document.AddUser.Username.value)) {
			alert("The Username field contains illegal characters.");

			return false;
		}

		document.AddUser.submit();
	}
}

function checkInput2() {
	if (document.AddApp.AppName.value == "") {
		alert("You must enter an Application Name.");

		return false;
	}
	else {
		if (badCharacters(document.AddApp.AppName.value)) {
			alert("The Application Name field contains illegal characters.");

			return false;
		}

		document.AddApp.submit();
	}
}

function checkInput3() {
	var i         = "";
	var strAppIDs = "";

	for (i = 0; i < document.UpdateUser.AllowedApps.options.length; i++) {
		if (document.UpdateUser.AllowedApps.options[i].value != "") {
			strAppIDs += document.UpdateUser.AllowedApps.options[i].value + ",";
		}
	}

	document.location.href = 'updateuser.asp?UserID=' + document.UpdateUser.UserID.value + '&UserEnabled=' + document.UpdateUser.UserEnabled.checked + '&AllowedAppIDs=' + strAppIDs;
}

function checkInput4() {
	var i          = "";
	var strUserIDs = "";
	var strEXEIDs  = "";

	for (i = 0; i < document.UpdateApp.AllowedUsers.options.length; i++) {
		if (document.UpdateApp.AllowedUsers.options[i].value != "") {
			strUserIDs += document.UpdateApp.AllowedUsers.options[i].value + ",";
		}
	}

	for (i = 0; i < document.UpdateApp.AppEXEs.length; i++) {
		if (document.UpdateApp.AppEXEs[i].checked) {
			strEXEIDs += document.UpdateApp.AppEXEs[i].value + ",";
		}
	}

	if (strEXEIDs == "") {
		if (document.UpdateApp.AppEXEs.checked) {
			strEXEIDs = document.UpdateApp.AppEXEs.value + ",";
		}
	}

	document.location.href = 'updateapp.asp?AppID=' + document.UpdateApp.AppID.value + '&AllowedUserIDs=' + strUserIDs + '&AppEXEIDs=' + strEXEIDs;
}

function checkInput5() {
	var i               = "";
	var strExemptEXEIDs = "";

	for (i = 0; i < document.UpdateExemptEXEs.ExemptEXEs.length; i++) {
		if (document.UpdateExemptEXEs.ExemptEXEs[i].checked) {
			strExemptEXEIDs += document.UpdateExemptEXEs.ExemptEXEs[i].value + ",";
		}
	}

	if (strExemptEXEIDs == "") {
		if (document.UpdateExemptEXEs.ExemptEXEs.checked) {
			strExemptEXEIDs = document.UpdateExemptEXEs.ExemptEXEs.value + ",";
		}
	}

	document.location.href = 'updateexemptexes.asp?ExemptEXEIDs=' + strExemptEXEIDs;
}

function checkInput6() {
	var strEMailAddress = "";

	strEMailAddress = document.ContactSupport.EMail.value;

	if (document.ContactSupport.Name.value == "") {
		alert("Please provider a name in the \"First \& Last Name\" field.");

		return false;
	}

	if (strEMailAddress == "" || strEMailAddress.indexOf('@') == -1) {
		alert("Please provider an e-mail address in the \"E-Mail Address\" field (i.e. youremail\@yourdomain.com).");

		return false;
	}

	if (document.ContactSupport.Content.value == "") {
		alert("Please provider any comments in the \"Comments\" field.");

		return false;
	}

	document.ContactSupport.submit();
}

function modifySelected1() {
	var i = "";
	var x = "";

	if (document.ModifyUser.UserList.options.length > 0) {
		for (i = 0; i < document.ModifyUser.UserList.options.length; i++) {
			if (document.ModifyUser.UserList.options[i].selected && document.ModifyUser.UserList.options[i].value != "") {
				x = 1;

				document.location.href = 'modifyuser.asp?UserID=' + document.ModifyUser.UserList.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select a user to modify.");
	}
}

function modifySelected2() {
	var i = "";
	var x = "";

	if (document.ModifyApp.AppList.options.length > 0) {
		for (i = 0; i < document.ModifyApp.AppList.options.length; i++) {
			if (document.ModifyApp.AppList.options[i].selected && document.ModifyApp.AppList.options[i].value != "") {
				x = 1;

				document.location.href = 'modifyapp.asp?AppID=' + document.ModifyApp.AppList.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select an application to modify.");
	}
}

function removeSelected1() {
	var i          = "";
	var x          = "";
	var strConfirm = "";

	if (document.ModifyUser.UserList.options.length > 0) {
		for (i = 0; i < document.ModifyUser.UserList.options.length; i++) {
			if (document.ModifyUser.UserList.options[i].selected && document.ModifyUser.UserList.options[i].value != "") {
				x = 1;

				strConfirm = confirm("Are you sure you want to remove the selected user?");

				if (strConfirm == false) {
					return false;
				}

				document.location.href = 'removeuser.asp?UserID=' + document.ModifyUser.UserList.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select a user to remove.");
	}
}

function removeSelected2() {
	var i          = "";
	var x          = "";
	var strConfirm = "";

	if (document.ModifyApp.AppList.options.length > 0) {
		for (i = 0; i < document.ModifyApp.AppList.options.length; i++) {
			if (document.ModifyApp.AppList.options[i].selected && document.ModifyApp.AppList.options[i].value != "") {
				x = 1;

				strConfirm = confirm("Are you sure you want to remove the selected application?");

				if (strConfirm == false) {
					return false;
				}

				document.location.href = 'removeapp.asp?AppID=' + document.ModifyApp.AppList.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select an application to remove.");
	}
}

function cancel1() {
	document.location.href = 'manageusers.asp';
}

function cancel2() {
	document.location.href = 'manageapps.asp';
}

function cancel3() {
	document.location.href = 'manageexemptexes.asp';
}

function changeAccessRequest1() {
	var i            = "";
	var intRequestID = "";

	if (document.AccessRequests.RequestsByUser.options.length > 0) {
		for (i = 0; i < document.AccessRequests.RequestsByUser.options.length; i++) {
			if (document.AccessRequests.RequestsByUser.options[i].selected && document.AccessRequests.RequestsByUser.options[i].value != "") {
				intRequestID = document.AccessRequests.RequestsByUser.options[i].value;
			}
		}
	}

	document.location.href = 'accessrequests.asp?RequestID=' + intRequestID;
}

function changeAccessRequest2() {
	var i            = "";
	var intRequestID = "";

	if (document.AccessRequests.RequestsByApp.options.length > 0) {
		for (i = 0; i < document.AccessRequests.RequestsByApp.options.length; i++) {
			if (document.AccessRequests.RequestsByApp.options[i].selected && document.AccessRequests.RequestsByApp.options[i].value != "") {
				intRequestID = document.AccessRequests.RequestsByApp.options[i].value;
			}
		}
	}

	document.location.href = 'accessrequests.asp?RequestID=' + intRequestID;
}

function sortRequestsByApp(objSelect, intRequestID) {
	var i              = "";
	var strSelectArray = new Array();
	var strLookupArray = new Array();
	var objErase       = new Option();

	for (i = 0; i < objSelect.options.length; i++) {
		strLookupArray[objSelect.options[i].text] = objSelect.options[i].value;

		strSelectArray[i] = objSelect.options[i].text;
	}

	strSelectArray.sort();

	objSelect.length = 0;

	for(i = 0; i < strSelectArray.length; i++) {
		var objErase = new Option();

		objErase.text  = strSelectArray[i];
		objErase.value = strLookupArray[strSelectArray[i]];
		objSelect[i]   = objErase;
	}

	for (i = 0; i < objSelect.options.length; i++) {
		if (objSelect.options[i].value == intRequestID)
		{
			objSelect.options[i].selected = true;
		}
	}
}

function approveAccessRequest() {
	var i = "";
	var x = "";

	if (document.AccessRequests.RequestsByUser.options.length > 0) {
		for (i = 0; i < document.AccessRequests.RequestsByUser.options.length; i++) {
			if (document.AccessRequests.RequestsByUser.options[i].selected && document.AccessRequests.RequestsByUser.options[i].value != "") {
				x = 1;

				document.location.href = 'processaccessrequest.asp?Process=Approve&RequestID=' + document.AccessRequests.RequestsByUser.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select either a user or an application.");
	}
}

function denyAccessRequest() {
	var i = "";
	var x = "";

	if (document.AccessRequests.RequestsByUser.options.length > 0) {
		for (i = 0; i < document.AccessRequests.RequestsByUser.options.length; i++) {
			if (document.AccessRequests.RequestsByUser.options[i].selected && document.AccessRequests.RequestsByUser.options[i].value != "") {
				x = 1;

				document.location.href = 'processaccessrequest.asp?Process=Deny&RequestID=' + document.AccessRequests.RequestsByUser.options[i].value;
			}
		}
	}

	if (x != 1) {
		alert("You must select either a user or an application.");
	}
}

function showError(strEXEPath) {
	var strMsg = "";

	strMsg = "You cannot approve access to an EXE file that is not associated with ";
	strMsg = strMsg + "an application. If you want to approve this request add a new ";
	strMsg = strMsg + "application on the Manage Applications page and associate the ";
	strMsg = strMsg + "EXE file below with the newly created application. After these ";
	strMsg = strMsg + "steps have been completed you can approve this access request ";
	strMsg = strMsg + "for the user.\n";
	strMsg = strMsg + "\n";
	strMsg = strMsg + "EXE Name:\n";
	strMsg = strMsg + "\n";
	strMsg = strMsg + strEXEPath;

	alert(strMsg);
}

function viewLog(intLogID) {
	document.location.href = 'logs.asp?LogID=' + intLogID;
}

function viewReport(intReportID) {
	document.location.href = 'reports.asp?ReportID=' + intReportID;
}

function licenseExpired() {
	var strMsg = "";

	strMsg = "Your Realtime Application Security 2006 license has expired. To obtain ";
	strMsg = strMsg + "a permanent license please contact the i1 Labs Sales Team at ";
	strMsg = strMsg + "sales@i1labs.com.";

	alert(strMsg);
}

function badCharacters(strTestString) {
	var strChars = "";

	strChars = /[\'\"\&\;\#\-]/;

	if (strChars.test(strTestString)) {
		return true;
	}
	else {
		return false;
	}
}
